<?
/*
Plugin Name: AK: Featured Post Sidebar Widget
Plugin URI: http://cssboss.com/featured_post
Description: Easily configure this widget to display any amount of posts (from 1 to 99) from a category into any widgetized area of your blog. Video is more my style, so check out this video tutorial I made for the plugin <a href="http://www.youtube.com/watch?v=eWhafkO7uJQ">Here</a>
Version: 1.4
Author: Andrew Kaser
Author URI: http://www.andrewkaser.com
Text-Domain: ak-featured-posted
*/

/*  Copyright 2012  ANDREW KASER  (email : Kaser@CSSBoss.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

	class ak_featured_post_widget extends WP_Widget {
		public function __construct() 
		{
			parent::__construct(
	 			'ak_featured_post_widget', // Base ID
				'AK: Featured Post', // Name
				array( 'description' => __( 'Display the latest post from a category', 'text_domain' ), ) // Args
			);
		}
	
		public function ak_featured_post()
		{
			$widget_ops = array(
				'classname'=>'ak-featured-post', // class that will be added to li element in widgeted area ul
				'description'=>'Display post from category' // description displayed in admin
			);
			$control_ops = array(
				'width'=>200, 'height'=>250, // width of input widget in admin
				'id_base'=>'ak-featured-post' // base of id of li element ex. id="example-widget-1"
			);
			$this->WP_Widget('ak_featured_post', 'AK: Featured Post', $widget_ops, $control_ops); // "Example Widget" will be name in control panel
		}
		
		public function form($instance)
		{
			if (isset($instance['category'])){ $category = $instance[ 'category' ]; } else { $category = __( 'Featured', 'text_domain' ); }
			if (isset($instance['title'])){ $title = $instance['title']; } else { $title = __('Featured Post','text_domain'); }
			if (isset($instance['link_title_to_cat'])){ $link_title_to_cat = $instance['link_title_to_cat']; } else { $link_title_to_cat = __('checked','text_domain'); }
			if (isset($instance['show_post_title'])){ $show_post_title = $instance['show_post_title']; } else { $show_post_title = __('checked','text_domain'); }
			if (isset($instance['show_post_limit'])){ $show_post_limit = $instance['show_post_limit']; } else { $show_post_limit = __('1','text_domain'); }
			if (isset($instance['show_featured_image'])){ $show_featured_image = $instance['show_featured_image']; } else { $show_featured_image = __('checked','text_domain'); }
			if (isset($instance['show_support_link'])){ $show_support_link = $instance['show_support_link']; } else { $show_support_link = __('checked','text_domain'); }
			?>
			<p>
				<label for="<?php echo $this->get_field_id( 'show_post_limit' ); ?>"><?php _e( 'Show How Many Posts:' ); ?></label> 
				<input class="widefat" id="<?php echo $this->get_field_id( 'show_post_limit' ); ?>" name="<?php echo $this->get_field_name( 'show_post_limit' ); ?>" type="text" value="<?php echo esc_attr( $show_post_limit ); ?>" maxlength="2" style="width: 25px;" />
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
				<input id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'link_title_to_cat' ); ?>"><?php _e( 'Link Title To Category :' ); ?></label> 
				<input id="<?php echo $this->get_field_id( 'link_title_to_cat' ); ?>" name="<?php echo $this->get_field_name( 'link_title_to_cat' ); ?>" type="checkbox" value="<?php echo esc_attr( $link_title_to_cat ); ?>" <?php checked( (bool) $link_title_to_cat, true ); ?> />
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'category' ); ?>"><?php _e( 'Category :' ); ?></label> 
				<select id="<?php echo $this->get_field_id( 'catgeory' ); ?>" name="<?php echo $this->get_field_name( 'category' ); ?>" >
					<?php
						$categories_list = get_categories();
						foreach ($categories_list as $list_category ) {
							
							if ( $list_category->cat_ID == $category ) {
								$selected = 'selected="selected"';
							} else {
								$selected = '';
							}
							
							echo '<option value="'.$list_category->cat_ID.'" '. selected($list_category->cat_ID, $instance['category']).'>'. $list_category->cat_name.'</option>';
						}
					?>
				</select>
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'show_post_title' ); ?>"><?php _e( 'Show Post Title :' ); ?></label> 
				<input id="<?php echo $this->get_field_id( 'show_post_title' ); ?>" name="<?php echo $this->get_field_name( 'show_post_title' ); ?>" type="checkbox" value="<?php echo esc_attr( $show_post_title ); ?>" <?php checked( (bool) $show_post_title, true ); ?> />
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'show_featured_image' ); ?>"><?php _e( 'Show Featured Image :' ); ?></label> 
				<input id="<?php echo $this->get_field_id( 'show_featured_image' ); ?>" name="<?php echo $this->get_field_name( 'show_featured_image' ); ?>" type="checkbox" value="<?php echo esc_attr( $show_featured_image ); ?>" <?php checked( (bool) $show_featured_image, true ); ?> />
			</p>
			
			<p>
				<label for="<?php echo $this->get_field_id( 'show_support_link' ); ?>"><?php _e( 'Show Support Link :' ); ?></label> 
				<input id="<?php echo $this->get_field_id( 'show_support_link' ); ?>" name="<?php echo $this->get_field_name( 'show_support_link' ); ?>" type="checkbox" value="<?php echo esc_attr( $show_support_link ); ?>" <?php checked( (bool) $show_support_link, true ); ?> />
			</p>
			<?php 
		}
		
		public function update($new_instance, $old_instance) 
		{
			// save the widget info
			$instance = array();
			$instance['show_post_limit'] = strip_tags( $new_instance['show_post_limit'] );
			$instance['category'] = strip_tags( $new_instance['category'] );
			$instance['link_title_to_cat'] = ( isset( $new_instance['link_title_to_cat'] ) ? 1 : 0 );
			$instance['title'] = strip_tags( $new_instance['title']);
			$instance['show_post_title'] =  ( isset( $new_instance['show_post_title'] ) ? 1 : 0 );
			$instance['show_featured_image'] =  ( isset( $new_instance['show_featured_image'] ) ? 1 : 0 );
			$instance['show_support_link'] =  ( isset( $new_instance['show_support_link'] ) ? 1 : 0 );
			return $instance;
		}
		
		public function widget($args, $instance) 
		{
			// let's save the post data for after the widget.
			global $post;
			$post_old = $post;
			
			extract( $args );	// grabbing all the args for the widget

			// setting all the args for the widget
			$title = apply_filters( 'widget_title', $instance['title'] );
			$category = $instance['category'];
			$link_title_to_cat = $instance['link_title_to_cat'];
			$show_post_title = $instance['show_post_title'];
			$show_post_limit = $instance['show_post_limit'];
			$show_featured_image = $instance['show_featured_image'];
			$show_support_link = $instance['show_support_link'];
			
			// start the widget
			echo $before_widget;					
			
			// Let's build the title of the widget
			if ( $link_title_to_cat ) { 
				echo $before_title . '<a href="' . get_category_link($category) . '">'.$title.'</a>'.$after_title;
			} else {
				echo $before_title . $title . $after_title;	
			}
			
			$ak_featured_posts_query = new WP_Query( 'cat='.$category.'&showposts='.$show_post_limit ); // get new post data
			while ( $ak_featured_posts_query->have_posts() ) : $ak_featured_posts_query->the_post(); 		
				$image_title = get_the_title();  // The alt text for the featured image
				?>
					<li>
						<a href="<?php the_permalink(); ?>">
							<?php 
								if ($show_post_title) 
								{
									the_title(); // To show the title of the post, or not... That is the question
								} 
					
								if ( $show_featured_image ) 
								{
									if ( has_post_thumbnail() ) 
									{
										the_post_thumbnail('medium', 
											array(
												'class' => 'ak_featured_post_image',
												'title' => $image_title
											)
										);
									} 		 
								}
							?>
						</a>
					</li>
				<?php
			 endwhile;
			
			if ( $show_support_link ) 
			{ 
				echo 'Powered By <a href="http://www.cssboss.com/featured_post" target="_blank">AK: Featured Post</a>'; 
			}
			
			echo $after_widget; // end widget
			$post = $post_old; // finally, restoring the original post data, as if we never even touched it ;)
		}
	}
	add_action( 'widgets_init', create_function( '', 'register_widget( "ak_featured_post_widget" );' ) );
?>